unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, Spin, PdfiumCore, PdfiumCtrl, LCLIntf, Math;

type

  { TForm1 }

  TForm1 = class(TForm)
    bScaleAuto: TButton;
    bScaleP: TButton;
    bOpen: TButton;
    bScaleM: TButton;
    bGetText: TButton;
    Label2: TLabel;
    bNext: TButton;
    odPDF: TOpenDialog;
    Panel3: TPanel;
    bPrev: TButton;
    ScrollBox1: TScrollBox;
    sePageNo: TSpinEdit;
    bClose: TButton;
    procedure bCloseClick(Sender: TObject);
    procedure bGetTextClick(Sender: TObject);
    procedure bNextClick(Sender: TObject);
    procedure bOpenClick(Sender: TObject);
    procedure bPrevClick(Sender: TObject);
    procedure bScaleAutoClick(Sender: TObject);
    procedure bScaleMClick(Sender: TObject);
    procedure bScalePClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sePageNoChange(Sender: TObject);
  private
    procedure WebLinkClick(Sender: TObject; Url: string);
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

uses
  Unit2;

var
  PDFCtrl: TPdfControl;

procedure TForm1.FormCreate(Sender: TObject);
begin
  PDFiumDllDir := ExtractFilePath(Application.ExeName);
  PDFCtrl := TPdfControl.Create(Self);
  PDFCtrl.Align := alClient;
  PDFCtrl.Parent := ScrollBox1;
  PDFCtrl.SendToBack;
  PDFCtrl.Color := clGray;
  PDFCtrl.PageColor := RGB(255, 255, 255);
  PDFCtrl.OnWebLinkClick := @WebLinkClick;
end;

procedure TForm1.bPrevClick(Sender: TObject);
begin
  PDFCtrl.GotoPrevPage;
  sePageNo.Value := PDFCtrl.PageIndex + 1;
end;

procedure TForm1.bScaleAutoClick(Sender: TObject);
begin
  PDFCtrl.ScaleMode := smFitHeight;
end;

procedure TForm1.bScaleMClick(Sender: TObject);
begin
  if PDFCtrl.ScaleMode <> smZoom then
    PDFCtrl.ScaleMode := smZoom;
  if PDFCtrl.ZoomPercentage > 25 then
    PDFCtrl.ZoomPercentage := PDFCtrl.ZoomPercentage - 5;
end;

procedure TForm1.bScalePClick(Sender: TObject);
begin
  if PDFCtrl.ScaleMode <> smZoom then
    PDFCtrl.ScaleMode := smZoom;
  if PDFCtrl.ZoomPercentage < 400 then
    PDFCtrl.ZoomPercentage := PDFCtrl.ZoomPercentage + 5;
end;

procedure TForm1.bNextClick(Sender: TObject);
begin
  PDFCtrl.GotoNextPage;
  sePageNo.Value := PDFCtrl.PageIndex + 1;
end;

procedure TForm1.bCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.bGetTextClick(Sender: TObject);
var
  s: String;
begin
  s := PDFCtrl.CurrentPage.ReadText(0, PDFCtrl.CurrentPage.GetCharCount);
  if s = '' then
  begin
    ShowMessage('Page no contains text');
    exit;
  end;
  Application.CreateForm(TForm2, Form2);
  Form2.Memo1.Lines.Text := s;
  Form2.ShowModal;
  FreeAndNil(Form2);
end;

procedure TForm1.bOpenClick(Sender: TObject);
begin
  if not odPDF.Execute then
    exit;
  PDFCtrl.ScaleMode := smFitHeight;
  PDFCtrl.LoadFromFile(odPDF.FileName);
  Caption := odPDF.FileName;
  sePageNo.Enabled := PDFCtrl.PageCount > 1;
  bPrev.Enabled := PDFCtrl.PageCount > 1;
  bNext.Enabled := PDFCtrl.PageCount > 1;
end;

procedure TForm1.sePageNoChange(Sender: TObject);
begin
  if sePageNo.Value <= PDFCtrl.PageCount then
    PDFCtrl.PageIndex := sePageNo.Value - 1
  else
    sePageNo.Value := PDFCtrl.PageCount;
end;

procedure TForm1.WebLinkClick(Sender: TObject; Url: string);
begin
  OpenURL(Url);
end;

end.

